/*	
 *	clipbary.c
 *
 *	ėprbgz
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2011 Naoyuki Sawa
 *
 *	* Tue Dec 20 00:06:44 JST 2011 Naoyuki Sawa
 *	- 1st [XB
 */
#include "clip.h"

/*****************************************************************************
 *	
 *****************************************************************************/

#ifndef PIECE
int bitarray_get(const void* ptr, int pos, int bits) {
	//
	//	                                              s2               s1
	//	                                              /                /
	//	                                        +----------+----------------------+
	//	MSB|........ .......x xxxxxxxx xxxxxxxx|xxxxxxxx xxx..... ........ ........|LSB
	//	                    +------------------------------+                      |
	//	                                   /               |                      |
	//	                                 bits             pos                     p
	//	             mask = 1_11111111_11111111_11111111_111
	//
	int value;
	int s1;
	int s2;
	int mask;
	const int* p;

	/* 1bitAyсA32bit߂̑͑ΉĂ܂B */
	if((bits < 1) || (bits > 32)) {
		DIE();
	}

	/* 32bitPʂ̃|C^߂܂B */
	p = (const int*)ptr + (pos >> 5);
	/* p[0]̈ʒuintlɊ܂܂Asvbit߂܂B */
	s1 = pos & 31;	/* 0`31 */
	/* p[0]̈ʒuintlɊ܂܂AKvbit߂܂B */
	s2 = 32 - s1;	/* 1`32 */

	/* p[0]̈ʒuintlAKvbit擾܂B */
	value = (unsigned)p[0] >> s1;
	/* p[1]̈ʒuintlɁAKvbit܂Ăc */
	if(bits > s2) {
		/* p[1]̈ʒuintlAKvbit擾܂B */
		value |= (unsigned)p[1] << s2;
	}

	/* svbit}XN܂B(Kvbit̕g͍sȂ) */
	mask = (unsigned)-1 >> (32 - bits);
	value &= mask;

	return value;
}
#else /*PIECE*/
asm("
		.code
		.align		1
		.global		bitarray_get
bitarray_get:
		;//-------------------------------------;//
		;// %r12 := ptr
		;// %r13 := pos
		;// %r14 := bits
		xand		%r4, %r13, 31		;// %r4  := s1 = pos & 31
;//{{xldextgߖ
;//		xld.w		%r5, 32			;// %r5  := s2 = 32 - s1
;//		sub		%r5, %r4
;//xldextgߖ
		not		%r5, %r4		;// %r5  := s2 = 32 - s1 = 33 + ~s1
		add		%r5, 33
;//}}xldextgߖ
		srl		%r13, 5			;// %r12 := p = (const int*)ptr + (pos >> 5)
		sll		%r13, 2
		add		%r12, %r13
		;//-------------------------------------;//
		;// %r4  := s1
		;// %r5  := s2
		;// %r12 := p
		;// %r14 := bits
		ld.w		%r10, [%r12]+		;// %r10 := value = (unsigned)p[0]
;//{{%r4j󂵂Ăǂ̂xsrlœK
;//		xsrl		%r10, %r4		;// %r10 := value = (unsigned)p[0] >> s1
;//%r4j󂵂Ăǂ̂xsrlœK
		cmp		%r4, 8			;//<---+
		jrle		4			;//--+ |
		srl		%r10, 8			;//  | |
		jp.d		-3			;//--|-+
		sub		%r4, 8			;//  |				*delay*
		srl		%r10, %r4		;//<-+
;//}}%r4j󂵂Ăǂ̂xsrlœK
		;//-------------------------------------;//
		;// %r5  := s2
		;// %r10 := value
		;// %r12 := p
		;// %r14 := bits
		cmp		%r14, %r5		;// if(bits > s2)
		jrle.d		10			;//---------------------------------------------+
		 ld.w		%r6, -1			;//   %r6  := -1		*delay*		|
		 ld.w		%r11, [%r12]		;//   %r11 := (unsigned)p[1]			|
;//{{%r5j󂵂Ăǂ̂xsllœK		;//						|
;//		 xsll		%r11, %r5		;//   %r11 := (unsigned)p[1] << s2		|
;//%r5j󂵂Ăǂ̂xsllœK		;//						|
		 cmp		%r5, 8			;//<---+					|
		 jrle		4			;//--+ |					|
		 sll		%r11, 8			;//  | |					|
		 jp.d		-3			;//--|-+					|
		 sub		%r5, 8			;//  |				*delay*		|
		 sll		%r11, %r5		;//<-+						|
;//}}%r5j󂵂Ăǂ̂xsllœK		;//						|
		 or		%r10, %r11		;// %r10 := value |= (unsigned)p[1] << s2	|
		;//-------------------------------------;//<--------------------------------------------+
		;// %r6  := -1
		;// %r10 := value
		;// %r14 := bits
;//{{xldextgߖ
;//		xld.w		%r7, 32			;// %r7  := 32 - bits
;//		sub		%r7, %r14
;//xldextgߖ
		not		%r7, %r14		;// %r7  := 32 - bits = 33 + ~bits
		add		%r7, 33
;//}}xldextgߖ
;//{{%r7j󂵂Ăǂ̂xsrlœK
;//		xsrl		%r6, %r7		;// %r6  := mask = (unsigned)-1 >> (32 - bits)
;//%r7j󂵂Ăǂ̂xsrlœK
		cmp		%r7, 8			;//<---+
		jrle		4			;//--+ |
		srl		%r6, 8			;//  | |
		jp.d		-3			;//--|-+
		sub		%r7, 8			;//  |				*delay*
		srl		%r6, %r7		;//<-+
;//}}%r7j󂵂Ăǂ̂xsrlœK
		ret.d
		and		%r10, %r6		;// %r10 := value &= mask	*delay*
");
#endif/*PIECE*/

/*****************************************************************************
 *	
 *****************************************************************************/

#ifndef PIECE
void bitarray_set(void* ptr, int pos, int bits, int value) {
	//
	//	                                              s2               s1
	//	                                              /                /
	//	                                        +----------+----------------------+
	//	MSB|........ .......x xxxxxxxx xxxxxxxx|xxxxxxxx xxx..... ........ ........|LSB
	//	                    +------------------------------+                      |
	//	                                   /               |                      |
	//	                                 bits             pos                     p
	//	             mask = 1_11111111_11111111_11111111_111
	//
	int s1;
	int s2;
	int mask;
	int* p;

	/* 1bitAyсA32bit߂̑͑ΉĂ܂B */
	if((bits < 1) || (bits > 32)) {
		DIE();
	}

	/* 32bitPʂ̃|C^߂܂B */
	p = (int*)ptr + (pos >> 5);
	/* p[0]̈ʒuintlɊ܂܂Asvbit߂܂B */
	s1 = pos & 31;	/* 0`31 */
	/* p[0]̈ʒuintlɊ܂܂AKvbit߂܂B */
	s2 = 32 - s1;	/* 1`32 */

	/* i[ĺAsvbit}XN܂B */
	mask = (unsigned)-1 >> (32 - bits);
	value &= mask;

	/* p[0]̈ʒuintlɁAKvbit܂B */
	p[0] &= ~((unsigned)mask  << s1);
	p[0] |=   (unsigned)value << s1;
	/* p[1]̈ʒuintlɁAKvbit܂Ăc */
	if(bits > s2) {
		/* p[1]̈ʒuintlɁAKvbit܂B */
		p[1] &= ~((unsigned)mask  >> s2);
		p[1] |=   (unsigned)value >> s2;
	}
}
#else /*PIECE*/
asm("
		.code
		.align		1
		.global		bitarray_set
bitarray_set:
		;//-------------------------------------;//
		;// %r12 := ptr
		;// %r13 := pos
		;// %r14 := bits
		;// %r15 := value
		xand		%r4, %r13, 31		;// %r4  := s1 = pos & 31
;//{{xldextgߖ
;//		xld.w		%r5, 32			;// %r5  := s2 = 32 - s1
;//		sub		%r5, %r4
;//xldextgߖ
		not		%r5, %r4		;// %r5  := s2 = 32 - s1 = 33 + ~s1
		add		%r5, 33
;//}}xldextgߖ
		srl		%r13, 5			;// %r12 := p = (const int*)ptr + (pos >> 5)
		sll		%r13, 2
		add		%r12, %r13
		;//-------------------------------------;//
		;// %r4  := s1
		;// %r5  := s2
		;// %r12 := p
		;// %r14 := bits
		;// %r15 := value
		ld.w		%r6, -1			;// %r6  := -1
;//{{xldextgߖ
;//		xld.w		%r7, 32			;// %r7  := 32 - bits
;//		sub		%r7, %r14
;//xldextgߖ
		not		%r7, %r14		;// %r7  := 32 - bits = 33 + ~bits
		add		%r7, 33
;//}}xldextgߖ
;//{{%r7j󂵂Ăǂ̂xsrlœK
;//		xsrl		%r6, %r7		;// %r6  := mask = (unsigned)-1 >> (32 - bits)
;//%r7j󂵂Ăǂ̂xsrlœK
		cmp		%r7, 8			;//<---+
		jrle		4			;//--+ |
		srl		%r6, 8			;//  | |
		jp.d		-3			;//--|-+
		sub		%r7, 8			;//  |				*delay*
		srl		%r6, %r7		;//<-+
;//}}%r7j󂵂Ăǂ̂xsrlœK
		and		%r15, %r6		;// %r15 := value &= mask
		;//-------------------------------------;//
		;// %r4  := s1
		;// %r5  := s2
		;// %r6  := mask
		;// %r12 := p
		;// %r14 := bits
		;// %r15 := value
		ld.w		%r7, [%r12]		;// %r7  := tmp = p[0]
		ld.w		%r10, %r6		;// %r10 :=                   mask
		ld.w		%r11, %r15		;// %r11 :=                   value
;//{{%r4j󂵂Ăǂ̂xsllœK
;//		xsll		%r10, %r4		;// %r10 :=         (unsigned)mask  << s1
;//		xsll		%r11, %r4		;// %r11 :=         (unsigned)value << s1
;//%r4j󂵂Ăǂ̂xsllœK
		cmp		%r4, 8			;//<---+
		jrle		5			;//--+ |
		sll		%r10, 8			;//  | |
		sll		%r11, 8			;//  | |
		jp.d		-4			;//--|-+
		sub		%r4, 8			;//  |				*delay*
		sll		%r10, %r4		;//<-+
		sll		%r11, %r4
;//}}%r4j󂵂Ăǂ̂xsllœK
		not		%r10, %r10		;// %r10 :=       ~((unsigned)mask  << s1)
		and		%r7, %r10		;// %r7  := tmp & ~((unsigned)mask  << s1)
		or		%r7, %r11		;// %r7  := tmp & ~((unsigned)mask  << s1) | ((unsigned)value << s1)
		ld.w		[%r12]+, %r7		;// p[0]  = tmp
		;//-------------------------------------;//
		;// %r5  := s2
		;// %r6  := mask
		;// %r12 := p
		;// %r14 := bits
		;// %r15 := value
		cmp		%r14, %r5		;// if(bits > s2)
		jrle		14			;//---------------------------------------------------------------------+
		 ld.w		%r7, [%r12]		;//   %r7  := tmp = p[1]						|
;//{{%r5j󂵂Ăǂ̂xsrlœK		;//									|
;//		 xsrl		%r6, %r5		;//   %r6  :=         (unsigned)mask  >> s2				|
;//		 xsrl		%r15, %r5		;//   %r15 :=         (unsigned)value >> s2				|
;//%r5j󂵂Ăǂ̂xsrlœK		;//									|
		 cmp		%r5, 8			;//<---+								|
		 jrle		5			;//--+ |								|
		 srl		%r6, 8			;//  | |								|
		 srl		%r15, 8			;//  | |								|
		 jp.d		-4			;//--|-+								|
		 sub		%r5, 8			;//  |				*delay*					|
		 srl		%r6, %r5		;//<-+									|
		 srl		%r15, %r5		;//									|
;//}}%r5j󂵂Ăǂ̂xsrlœK		;//									|
		 not		%r6, %r6		;//   %r6  :=       ~((unsigned)mask  >> s2)				|
		 and		%r7, %r6		;//   %r7  := tmp & ~((unsigned)mask  >> s2)				|
		 or		%r7, %r15		;//   %r7  := tmp & ~((unsigned)mask  >> s2) | ((unsigned)value >> s2)	|
		 ld.w		[%r12], %r7		;//   p[1]  = tmp							|
		ret					;//<--------------------------------------------------------------------+
");
#endif/*PIECE*/
